from .base_config import BaseConfig, ModelConfig

from dataclasses import dataclass, field

from hydra.core.config_store import ConfigStore


features_to_check = [
    "acc_x",
    "acc_y",
    "acc_z",
    "rot_w",
    "rot_x",
    "rot_y",
    "rot_z",
    "thm_1",
    "thm_2",
    "thm_3",
    "thm_4",
    "thm_5",
    "tof_1_v0",
    "tof_1_v1",
    "tof_1_v2",
    "tof_1_v3",
    "tof_1_v4",
    "tof_1_v5",
    "tof_1_v6",
    "tof_1_v7",
    "tof_1_v8",
    "tof_1_v9",
    "tof_1_v10",
    "tof_1_v11",
    "tof_1_v12",
    "tof_1_v13",
    "tof_1_v14",
    "tof_1_v15",
    "tof_1_v16",
    "tof_1_v17",
    "tof_1_v18",
    "tof_1_v19",
    "tof_1_v20",
    "tof_1_v21",
    "tof_1_v22",
    "tof_1_v23",
    "tof_1_v24",
    "tof_1_v25",
    "tof_1_v26",
    "tof_1_v27",
    "tof_1_v28",
    "tof_1_v29",
    "tof_1_v30",
    "tof_1_v31",
    "tof_1_v32",
    "tof_1_v33",
    "tof_1_v34",
    "tof_1_v35",
    "tof_1_v36",
    "tof_1_v37",
    "tof_1_v38",
    "tof_1_v39",
    "tof_1_v40",
    "tof_1_v41",
    "tof_1_v42",
    "tof_1_v43",
    "tof_1_v44",
    "tof_1_v45",
    "tof_1_v46",
    "tof_1_v47",
    "tof_1_v48",
    "tof_1_v49",
    "tof_1_v50",
    "tof_1_v51",
    "tof_1_v52",
    "tof_1_v53",
    "tof_1_v54",
    "tof_1_v55",
    "tof_1_v56",
    "tof_1_v57",
    "tof_1_v58",
    "tof_1_v59",
    "tof_1_v60",
    "tof_1_v61",
    "tof_1_v62",
    "tof_1_v63",
    "tof_2_v0",
    "tof_2_v1",
    "tof_2_v2",
    "tof_2_v3",
    "tof_2_v4",
    "tof_2_v5",
    "tof_2_v6",
    "tof_2_v7",
    "tof_2_v8",
    "tof_2_v9",
    "tof_2_v10",
    "tof_2_v11",
    "tof_2_v12",
    "tof_2_v13",
    "tof_2_v14",
    "tof_2_v15",
    "tof_2_v16",
    "tof_2_v17",
    "tof_2_v18",
    "tof_2_v19",
    "tof_2_v20",
    "tof_2_v21",
    "tof_2_v22",
    "tof_2_v23",
    "tof_2_v24",
    "tof_2_v25",
    "tof_2_v26",
    "tof_2_v27",
    "tof_2_v28",
    "tof_2_v29",
    "tof_2_v30",
    "tof_2_v31",
    "tof_2_v32",
    "tof_2_v33",
    "tof_2_v34",
    "tof_2_v35",
    "tof_2_v36",
    "tof_2_v37",
    "tof_2_v38",
    "tof_2_v39",
    "tof_2_v40",
    "tof_2_v41",
    "tof_2_v42",
    "tof_2_v43",
    "tof_2_v44",
    "tof_2_v45",
    "tof_2_v46",
    "tof_2_v47",
    "tof_2_v48",
    "tof_2_v49",
    "tof_2_v50",
    "tof_2_v51",
    "tof_2_v52",
    "tof_2_v53",
    "tof_2_v54",
    "tof_2_v55",
    "tof_2_v56",
    "tof_2_v57",
    "tof_2_v58",
    "tof_2_v59",
    "tof_2_v60",
    "tof_2_v61",
    "tof_2_v62",
    "tof_2_v63",
    "tof_3_v0",
    "tof_3_v1",
    "tof_3_v2",
    "tof_3_v3",
    "tof_3_v4",
    "tof_3_v5",
    "tof_3_v6",
    "tof_3_v7",
    "tof_3_v8",
    "tof_3_v9",
    "tof_3_v10",
    "tof_3_v11",
    "tof_3_v12",
    "tof_3_v13",
    "tof_3_v14",
    "tof_3_v15",
    "tof_3_v16",
    "tof_3_v17",
    "tof_3_v18",
    "tof_3_v19",
    "tof_3_v20",
    "tof_3_v21",
    "tof_3_v22",
    "tof_3_v23",
    "tof_3_v24",
    "tof_3_v25",
    "tof_3_v26",
    "tof_3_v27",
    "tof_3_v28",
    "tof_3_v29",
    "tof_3_v30",
    "tof_3_v31",
    "tof_3_v32",
    "tof_3_v33",
    "tof_3_v34",
    "tof_3_v35",
    "tof_3_v36",
    "tof_3_v37",
    "tof_3_v38",
    "tof_3_v39",
    "tof_3_v40",
    "tof_3_v41",
    "tof_3_v42",
    "tof_3_v43",
    "tof_3_v44",
    "tof_3_v45",
    "tof_3_v46",
    "tof_3_v47",
    "tof_3_v48",
    "tof_3_v49",
    "tof_3_v50",
    "tof_3_v51",
    "tof_3_v52",
    "tof_3_v53",
    "tof_3_v54",
    "tof_3_v55",
    "tof_3_v56",
    "tof_3_v57",
    "tof_3_v58",
    "tof_3_v59",
    "tof_3_v60",
    "tof_3_v61",
    "tof_3_v62",
    "tof_3_v63",
    "tof_4_v0",
    "tof_4_v1",
    "tof_4_v2",
    "tof_4_v3",
    "tof_4_v4",
    "tof_4_v5",
    "tof_4_v6",
    "tof_4_v7",
    "tof_4_v8",
    "tof_4_v9",
    "tof_4_v10",
    "tof_4_v11",
    "tof_4_v12",
    "tof_4_v13",
    "tof_4_v14",
    "tof_4_v15",
    "tof_4_v16",
    "tof_4_v17",
    "tof_4_v18",
    "tof_4_v19",
    "tof_4_v20",
    "tof_4_v21",
    "tof_4_v22",
    "tof_4_v23",
    "tof_4_v24",
    "tof_4_v25",
    "tof_4_v26",
    "tof_4_v27",
    "tof_4_v28",
    "tof_4_v29",
    "tof_4_v30",
    "tof_4_v31",
    "tof_4_v32",
    "tof_4_v33",
    "tof_4_v34",
    "tof_4_v35",
    "tof_4_v36",
    "tof_4_v37",
    "tof_4_v38",
    "tof_4_v39",
    "tof_4_v40",
    "tof_4_v41",
    "tof_4_v42",
    "tof_4_v43",
    "tof_4_v44",
    "tof_4_v45",
    "tof_4_v46",
    "tof_4_v47",
    "tof_4_v48",
    "tof_4_v49",
    "tof_4_v50",
    "tof_4_v51",
    "tof_4_v52",
    "tof_4_v53",
    "tof_4_v54",
    "tof_4_v55",
    "tof_4_v56",
    "tof_4_v57",
    "tof_4_v58",
    "tof_4_v59",
    "tof_4_v60",
    "tof_4_v61",
    "tof_4_v62",
    "tof_4_v63",
    "tof_5_v0",
    "tof_5_v1",
    "tof_5_v2",
    "tof_5_v3",
    "tof_5_v4",
    "tof_5_v5",
    "tof_5_v6",
    "tof_5_v7",
    "tof_5_v8",
    "tof_5_v9",
    "tof_5_v10",
    "tof_5_v11",
    "tof_5_v12",
    "tof_5_v13",
    "tof_5_v14",
    "tof_5_v15",
    "tof_5_v16",
    "tof_5_v17",
    "tof_5_v18",
    "tof_5_v19",
    "tof_5_v20",
    "tof_5_v21",
    "tof_5_v22",
    "tof_5_v23",
    "tof_5_v24",
    "tof_5_v25",
    "tof_5_v26",
    "tof_5_v27",
    "tof_5_v28",
    "tof_5_v29",
    "tof_5_v30",
    "tof_5_v31",
    "tof_5_v32",
    "tof_5_v33",
    "tof_5_v34",
    "tof_5_v35",
    "tof_5_v36",
    "tof_5_v37",
    "tof_5_v38",
    "tof_5_v39",
    "tof_5_v40",
    "tof_5_v41",
    "tof_5_v42",
    "tof_5_v43",
    "tof_5_v44",
    "tof_5_v45",
    "tof_5_v46",
    "tof_5_v47",
    "tof_5_v48",
    "tof_5_v49",
    "tof_5_v50",
    "tof_5_v51",
    "tof_5_v52",
    "tof_5_v53",
    "tof_5_v54",
    "tof_5_v55",
    "tof_5_v56",
    "tof_5_v57",
    "tof_5_v58",
    "tof_5_v59",
    "tof_5_v60",
    "tof_5_v61",
    "tof_5_v62",
    "tof_5_v63",
]

features_to_use = [
    *features_to_check,
    "acc_gx",
    "acc_gy",
    "acc_gz_no_gravity",
    "acc_magnitude",
    "alpha",
    "beta",
    "gamma",
]


label_category_to_int = {
    "Above ear - pull hair": 1,
    "Cheek - pinch skin": 1,
    "Drink from bottle/cup": 1,
    "Eyebrow - pull hair": 1,
    "Eyelash - pull hair": 1,
    "Feel around in tray and pull out an object": 1,
    "Forehead - pull hairline": 1,
    "Forehead - scratch": 1,
    "Glasses on/off": 1,
    "Neck - pinch skin": 1,
    "Neck - scratch": 1,
    "Pinch knee/leg skin": 1,
    "Pull air toward your face": 1,
    "Scratch knee/leg skin": 0,
    "Text on phone": 1,
    "Wave hello": 1,
    "Write name in air": 1,
    "Write name on leg": 1,
}

weight = [
    100.0,
    1.0,
]


@dataclass
class AttentionModelConfig(ModelConfig):
    d_model: int = 16
    n_head: int = 4
    num_layers: int = 2
    num_classes: int = 2
    input_dim: int = len(features_to_use)
    name: str = "a7_tcnt"


@dataclass
class TransformTcnGlobalFeaturesConfig(BaseConfig):
    features_to_use: list[str] = field(default_factory=lambda: features_to_use)
    features_to_check: list[str] = field(default_factory=lambda: features_to_check)
    model: AttentionModelConfig = field(default_factory=AttentionModelConfig)
    label_category_to_int: dict[str, int] = field(
        default_factory=lambda: label_category_to_int
    )
    weight: list[float] = field(default_factory=lambda: weight)

    patience: int = 5


def register_config():
    cs = ConfigStore.instance()
    cs.store(name="config", node=TransformTcnGlobalFeaturesConfig)
